
#ifndef __INTERFACES_HPP__
#define __INTERFACES_HPP__

#if (PLATAFORMA & LINUX)
  #include "ecf.hpp"
  #include "WinAPI.hpp" 
#else
  #include "..\..\Firmware\ecf.hpp"
#endif

#include "sw_vcl.h"

#ifndef DLL_IMPORT
#define DLL_IMPORT
#endif

#include "swmfd.h"



#define opPerfilA            (REGISTRO_C400 | \
                              REGISTRO_C405 | \
                              REGISTRO_C410 | \
                              REGISTRO_C420 | \
                              REGISTRO_C460 | \
                              REGISTRO_C470 | \
                              REGISTRO_C490)


#define opPerfilB            (REGISTRO_C400 | \
                              REGISTRO_C405 | \
                              REGISTRO_C410 | \
                              REGISTRO_C420 | \
                              REGISTRO_C425 | \
                              REGISTRO_C490)


#define opPerfilC            (REGISTRO_C400 | \
                              REGISTRO_C405 | \
                              REGISTRO_C410 | \
                              REGISTRO_C420 | \
                              REGISTRO_C425 | \
                              REGISTRO_C460 | \
                              REGISTRO_C470 | \
                              REGISTRO_C490 | \
                              REGISTRO_C495)



#define _MAX_PATH 260

#ifdef __BORLANDC__
#include <dir.h>
#endif


typedef void (_stdcall *TCallBack) (void*);


#define opCapturarFirmwareMFD  (1 << 7)



//#define VERSAO_INTERFACE_ECF_SWEDA 100

// INTERFACE COM MFD

struct INTERFACE_MFD : DATA_LOGGER_STATUS
{  unsigned char MFDHigh[0x7FFF];
   char szNomeArquivo[_MAX_PATH];
   INTERFACE_MFD ();
   void FecharArquivos();
   void ReabrirArquivos();
   bool AbrirArquivos(unsigned char*);
   int open (unsigned char*);
   int hLow, hHigh;
   struct BUFFER
   {  long endereco;
      unsigned char buffer[256];
   } bLow, bHigh;
   long A, B, C, D, Consumo;

   int OffsetH, OffsetL;
   ASSINATURA_MFD assinatura;
   INSTALACAO_MFD instalacao;
   USUARIO_MFD usuario;
};

extern INTERFACE_MFD iMFD0, iMFD1;



// INTERFACE COM MF

#define BASE_MF ((1024L*5)+1)

struct INTERFACE_MF
{  INTERFACE_MF ();
   char szNomeArquivo[_MAX_PATH];
   int read (long, void*, int);
   int open (unsigned char*);
   void FecharArquivo();
   void ReabrirArquivo();
   void AbrirArquivo(unsigned char*);
   unsigned char Cabecalho[BASE_MF];
   unsigned char setor[512];
   struct BUFFER
   {  long endereco;
      unsigned char buffer[1024];
   } buffer[4];
   MEMORIA_FISCAL *MF;
   int handle;
   int Offset;
   long tamanho;
};

extern INTERFACE_MF iMF;

bool AbrirArquivo (FILEn&, char*, char*, int = 3, void* = 0);
void ECF32Run ();




// SINTEGRA

struct TotalizacaoArquivoSintegra
{  TotalizacaoArquivoSintegra();
   unsigned long Registros10,
                 Registros11,
                 Registros60M,
                 Registros60A,
                 Registros60D,
                 Registros60I, 
                 Registros60R,
                 Registros75,
                 RegistrosP1,
                 RegistrosP2,
                 Registros;
};

#pragma pack (push, 1)
      struct TAcessoRemoto  
      {  short int Funcao;
         unsigned char Dispositivo;
         unsigned long Endereco;
         unsigned short int Low;
         unsigned short int High;
      };
#pragma pack (pop)


// Callback das funes de IO

struct TInfoCallBackIO
{  short int Evento;
   short int AutoDeteccao;
   short int Porta;
   long Velocidade;
   short int ControleFluxo;
};

typedef void (_stdcall *TCallBackIO) (struct TInfoCallBackIO*, void*);

// Classe de captura de dispositivos


class TCapturaDispositivo : public TInfoCallBackCD, public TThread
{  
   public:

      void Cancelar();
      
      struct TParametros
      {  short int Dispositivo;
         short int Opcoes;
         char Arquivo[260];
         char *Buffer;
         short int Extensao;
         long Timeout;
         TCallBackCD CallBack;
         void *Instancia;
      };

      TCapturaDispositivo();
      ~TCapturaDispositivo();

      virtual unsigned long Execute();
      short int SWEDA_CapturarDispositivo (short int, short int, char *Arquivo = 0, short int = 0, long = 15000, TCallBackCD CallBack = 0, void *Instancia = 0);
      short int SWEDA_CapturarDispositivo (short int, long, long, short int, char*, long = 15000, TCallBackCD CallBack = 0, void *Instancia = 0, char* = 0, long = 0);
      short int SWEDA_CapturarDispositivo (TParametros*);
      class TCapturaDispositivo *Instancia;
      virtual void OnTerminate();  
      
   protected:

      TIMER IDLEEventTimer;
      TParametros Parametros;
      long Tempos[50];
      long TempoTotal;
      short int Registros;
      static void _stdcall CallBackIO (TInfoCallBackIO*, TCapturaDispositivo*);

      static void _stdcall CapturandoDispositivo (TCapturaDispositivo*);
      void ChamarCallBack (short int);
      HWND hJanela;
};



///////////////////////////////////////////////////////////////////////////////////////////////////
class TExportacao : public TInfoCallBackExp, public TThread
{  public:
      TExportacao();
      ~TExportacao();

      struct TParametros 
      {  char szOrigem1[260];
         char szOrigem2[260];
         char szArquivoDestino[260];
         short int Formato;
         char szSelecaoInicial[20]; 
         char szSelecaoFinal[20];
         char szData[12];
         short int Opcoes;
         char *Buffer;
         long Extensao;
         TCallBackExp CallBack;
         void *Instancia;
         TParametrosSPED SPED;
      };                

      class TExportacao *Instancia;
      TPropriedadesDispositivo Propriedades1;
      TPropriedadesDispositivo Propriedades2;
      TParametros Parametros;
      short int Resultado;
      void Cancelar();
      void ChamarCallBack();

      short int SWEDA_Exportar (char *pszOrigem1, char *pszOrigem2, char *pszArquivoDestino, short int Formato, char *pszSelecaoInicial = "", char *pszSelecaoFinal = "", char *pszData = "", short int Opcoes = 0, TParametrosSPED* = 0, char *Buffer = 0, long Extensao = 0, TCallBackExp CallBack = 0, void *Instancia = 0);
      short int SWEDA_Exportar (TParametros*);

   private:
      virtual void OnStart();
      virtual void OnTerminate();

      unsigned long Execute();
      HWND hJanela;
      TIMER timer;

      short int SWEDA_ArquivoEletronicoCOTEPE();
      short int SWEDA_AuditarDispositivos ();
      short int SWEDA_ReproduzirFitaDetalhe();
      short int SWEDA_ReproduzirLeituraMemoriaFiscal();
      short int SWEDA_ArquivoSPED();
};


extern class TExportacao *Exportacao;


///////////////////////////////////////////////////////////////////////////////////////////////////

class TSintegra : public TotalizacaoArquivoSintegra, public TInfoCallBackSintegra, public TThread
{  public:
      
      struct TConsolidacaoDia : public TOTALIZACAO_RZ 
      {  TConsolidacaoDia();
         long COOInicial, 
              COOFinal;
         RELOGIO InicioDia;
         int18 GT;
         int18 VBISSQN;
         struct CRO CRO;
         struct CRZ CRZ;
         struct CFD CFD;

         short int Caixa;
         protected:
            TOTALIZACAO_RZ::PARCIAIS_TRIBUTADOS ParciaisTributados[200];
      };

      struct TParametros 
      {  char szSelecaoInicial[20];
         char szSelecaoFinal[20];
         unsigned short int RegistrosSelecionados;
         char szOrigem[260];
         char szArquivoDestino[260];
         TDadosEstabelecimento Estabelecimento;
         short int Opcoes;
         TCallBackSintegra CallBack;
         short int Mascara;
         char szArquivoLog[260];
         void *Instancia;
      };

// Informaes para rotina de callback da aplicao
      void Cancelar();

      void ChamarCallBack ();
      short int Resultado;

      class TSintegra *Instancia;
               
      struct TProdutos
      {  long Referencia;
         char SituacaoTributaria[4];
         char Codigo[15];
         DATA Validade;
      } *Produtos;

      long *Classificacao;

      struct TResumo
      {  int14 Quantidade;      
         __int64 BaseCalculo;    
         __int64 Descontos;       
      } *Resumo, *ResumoMensal;                   

      unsigned long Itens;
      unsigned long Capacidade;
      unsigned long EnderecoFinal;

      TSintegra();     
      ~TSintegra();     

      void ComputarDesconto(PRODUTO&, VALOR &);
      void ComputarCancelamento(PRODUTO&, QUANTIDADE&, VALOR&);
   
// Funo para gerao de registros
      void Tipo10 ();         // Tipo 10
      void Tipo11 ();                        // Tipo 11
      void Tipo60M (struct REDUCAO_Z&, class int18&, long, short int);     // Tipo 60 M
      void Tipo60M (TConsolidacaoDia&);
      void Tipo60A (struct REDUCAO_Z&);      // Tipo 60 A
      void Tipo60A (TConsolidacaoDia&);
      void Tipo60D (DATA &Data);             // Tipo 60 D
      void Tipo60I (ITEM&, bool);            // Tipo 60 I
      void Tipo60R ();                       // Tipo 60 R
      void Tipo75 ();                        // Tipo 75
      void Tipo90 ();                        // Tipo 90
      void TipoP1();
      void TipoP2();
      void TipoP9();


      void AbrirDia(bool = false);           // Abertura do dia
      void DescarregarCupom();
      void RZ();

      
      TParametros Parametros;                                                                                                               
      short int SWEDA_ArquivoSINTEGRA (char*, char*, char *, TDadosEstabelecimento*, short int = 0x7FFF, short int = 0, char* = "", char* = "", TCallBackSintegra = 0, void* = 0, short int = 0);
      short int SWEDA_ArquivoSINTEGRA (TParametros*);
                     
   protected:
      virtual unsigned long Execute();

      TConsolidacaoDia Dia;
//      TCapturaDispositivo Captura;

      struct TBuffer
      {  long Registros, Base, Item;
         int FileHandle;
         char *Buffer;
         long Capacidade;
         long Topo;
         struct TRegistro 
         {  char *Endereco;
            short int Tipo;
            char Subtipo;
         } Registro;
         void Set(char*, long, int, long, long);
         bool ProximoRegistro();
      };

      struct TArquivo : public TotalizacaoArquivoSintegra
      {  TArquivoOrigem *Origem;
         int ArquivoTemporario1;
         int ArquivoTemporario2;
         char DataInstalacao[11];
         long COOInicial; 
         long COOFinal;
         TBuffer Buffer;
      } Origem[100];
      
      static char* SituacaoTributaria (char *, char*);
      static char* SituacaoTributaria2 (char *, char*);
      static __int64 MontanteImposto (char *szAliquota, __int64 BaseCalculo);
      static int OrdenarNSFAB (TArquivo *, TArquivo *);
      static int OrdenarLojaECFNS (TArquivo *, TArquivo *);
      
      int AdicionarArquivo (char*, short int);

      bool AbrirArquivoSaida (char *);
      long CadastrarProduto (ITEM&);
      PRODUTO CarregarProduto(TProdutos&);
      void ExcluirArquivosTemporarios();
      long LocalizarReferencia (long);
      void LiberarRecursosSistema();
      long GravarRegistros (int, long, long, int);
      void GravarRegistro (char*, int);
      void AnalisarRegistro (char*, int);

      FILEn ArquivoDestino;
      FILEn Arquivo60I;
      FILEn Log;
      
      void Registro60A (char*, int14&, DATA&);      
      long UltimoResumoMensal;

//      DATA Emissao;
      DATA DataInicial, DataFinal;
      unsigned short int RegistrosSelecionados;
      TPropriedadesDispositivo Propriedades;
      char *pszCGC, *pszIE;
      char *pszFAB;
      char *MemoriaAlocada;
      long MemoriaDisponivel;
      TotalizacaoArquivoSintegra Geral;

      virtual void OnStart();
      virtual void OnTerminate();
      HWND hJanela;
};

      
// No rederinir a 
#pragma pack (push, 1)



struct TArquivoINI
{  char DiretorioSweda[260];
   struct TECF
   {  char FAB[22];
      char MFD[22];
   } ECF;
   struct TComunicacao
   {  short int Porta;
      long Velocidade;
      short int ControleFluxo;
   } Comunicacao;
   TDadosEstabelecimento Estabelecimento;
   struct TAssinaturaDigital
   {  short int Parametros[32];
      struct TChaveRSA
      {  short int Extensao;
         unsigned char Modulo[256];
         unsigned char Expoente[256];
      } ChavePublica[2];
      unsigned Reserva[1024];
   } AD;

   long Parametros[32];

   struct TParametrosSPED SPED;
};

#pragma pack (pop)
   

extern class TSintegra *Sintegra;


class TSWMFD : public TApplication
{  public:
      struct TArquivoINI : public ::TArquivoINI
      {  char NomeArquivo[512];
         bool Carregar();
         bool Atualizar(char* = 0);
      };

      TSWMFD();
      ~TSWMFD();
      HANDLE hMutexECF; 
      HANDLE hMutexIO;
      TArquivoINI ArquivoINI;
      bool DiretorioSistema;

      virtual void Terminate();
      virtual bool Attach();
};

extern class TSWMFD *SWMFD;

#define ARQUIVO_SINTEGRA              BIT5  


extern TInfoCallBackIO InfoIO;
extern class SCC SCC;
extern class ECF_IF *ECF;

#endif
